#line 1 "/home/abuild/rpmbuild/BUILD/clisp-2.49.92/modules/queens/callqueens.c"
/*
 * Interface to the queens() function
 */

#include "clisp.h"

DEFMODULE(queens,"USER")

void module__queens__init_function_1 (module_t* module);
void module__queens__init_function_2 (module_t* module);

#define O(varname) module__queens__object_tab._##varname
#define F(varname) subr_tab_ptr_as_object(&this_module_stab->_##varname)

struct module__queens__object_tab_t {
} module__queens__object_tab;
uintC module__queens__object_tab_size = sizeof(module__queens__object_tab)/sizeof(gcv_object_t);

struct module__queens__object_tab_initdata_t {
  int _dummy_to_avoid_trailing_comma_in_initializer;
} module__queens__object_tab_initdata = {
  0
};

struct module__queens__subr_tab_t {
  VAROBJECTS_ALIGNMENT_DUMMY_DECL
  subr_t _subr_user_queens;
  int _dummy_to_avoid_trailing_comma_in_initializer;
};
extern struct module__queens__subr_tab_t module__queens__subr_tab;

struct module__queens__stab_t {
  subr_t _subr_user_queens;
  int _dummy_to_avoid_trailing_comma_in_initializer;
};
static struct module__queens__stab_t* this_module_stab;



#line 8

#define nmax 100

/* extern declaration */
extern unsigned int queens (unsigned int n);

/*
 * (USER::QUEENS n) returns the number of solutions to the n-queens problem.
 * n ought to be an integer > 0, <= nmax. Otherwise it returns NIL.
 */
DEFUN(USER::QUEENS, n,(subr_user_queens,seclass_default,1,0,norest,nokey,0,NIL))
{ /*
   * garbage collection is not a problem,
   * so we get the argument from the STACK immediately,
   * and clean up STACK at the same time
   */
  unsigned int n = I_to_uint(check_uint(popSTACK()));
  if (n>0 && n<=nmax) { /* the argument is good. Do our job: */
    unsigned int result;
    begin_call();
    result = queens(n); /* call external function */
    end_call();
    /*
     * Assume result is >=0 and <2^32 (which is guaranteed by the type
     * of problem we have and the amount of time queens() may have run).
     * So an unsigned int' is enough, and the following call is appropriate.
     */
    VALUES1(uint_to_I(result)); /* convert result to a nonnegative integer */
  } else /* We could issue an error. We prefer to return NIL here. */
    VALUES1(NIL);
}



struct module__queens__subr_tab_t module__queens__subr_tab
  #if defined(HEAPCODES) && (alignment_long < varobject_alignment) && defined(__GNUC__)
    __attribute__ ((aligned (varobject_alignment)))
  #endif
  = {
  #if varobjects_misaligned
  { 0 },
  #endif
  LISPFUN_F(subr_user_queens,seclass_default,1,0,norest,nokey,0,NIL)
  0
};
uintC module__queens__subr_tab_size = (sizeof(struct module__queens__subr_tab_t)-varobjects_misaligned-sizeof(int))/sizeof(subr_t);

struct module__queens__subr_tab_initdata_t {
  subr_initdata_t _subr_user_queens;
  int _dummy_to_avoid_trailing_comma_in_initializer;
} module__queens__subr_tab_initdata = {
  { "USER", "QUEENS" },
  0
};

void module__queens__init_function_1 (module_t* module)
{
  this_module_stab = (struct module__queens__stab_t*)module->stab;
}

void module__queens__init_function_2 (module_t* module)
{
  this_module_stab = (struct module__queens__stab_t*)module->stab;
}

void module__queens__fini_function (module_t* module);
void module__queens__fini_function (module_t* module)
{
}
